=begin
#Treezor

#Treezor API.  more info [here](https://www.treezor.com). 

OpenAPI spec version: 0.1.1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.1

=end

require 'date'

module TreezorClient
  class Document
    attr_accessor :document_id

    attr_accessor :document_tag

    attr_accessor :document_status

    attr_accessor :document_type_id

    attr_accessor :document_type

    attr_accessor :residence_id

    attr_accessor :client_id

    attr_accessor :user_id

    attr_accessor :user_lastname

    attr_accessor :user_firstname

    attr_accessor :file_name

    attr_accessor :temporary_url

    attr_accessor :temporary_url_thumb

    attr_accessor :information_status

    # Date YYYY-MM-DD HH:MM:SS
    attr_accessor :created_date

    # Date YYYY-MM-DD HH:MM:SS
    attr_accessor :modified_date

    attr_accessor :total_rows

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'document_id' => :'documentId',
        :'document_tag' => :'documentTag',
        :'document_status' => :'documentStatus',
        :'document_type_id' => :'documentTypeId',
        :'document_type' => :'documentType',
        :'residence_id' => :'residenceId',
        :'client_id' => :'clientId',
        :'user_id' => :'userId',
        :'user_lastname' => :'userLastname',
        :'user_firstname' => :'userFirstname',
        :'file_name' => :'fileName',
        :'temporary_url' => :'temporaryUrl',
        :'temporary_url_thumb' => :'temporaryUrlThumb',
        :'information_status' => :'informationStatus',
        :'created_date' => :'createdDate',
        :'modified_date' => :'modifiedDate',
        :'total_rows' => :'totalRows'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'document_id' => :'Integer',
        :'document_tag' => :'String',
        :'document_status' => :'String',
        :'document_type_id' => :'Integer',
        :'document_type' => :'String',
        :'residence_id' => :'Integer',
        :'client_id' => :'Integer',
        :'user_id' => :'Integer',
        :'user_lastname' => :'String',
        :'user_firstname' => :'String',
        :'file_name' => :'String',
        :'temporary_url' => :'String',
        :'temporary_url_thumb' => :'String',
        :'information_status' => :'String',
        :'created_date' => :'String',
        :'modified_date' => :'String',
        :'total_rows' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'documentId')
        self.document_id = attributes[:'documentId']
      end

      if attributes.has_key?(:'documentTag')
        self.document_tag = attributes[:'documentTag']
      end

      if attributes.has_key?(:'documentStatus')
        self.document_status = attributes[:'documentStatus']
      end

      if attributes.has_key?(:'documentTypeId')
        self.document_type_id = attributes[:'documentTypeId']
      end

      if attributes.has_key?(:'documentType')
        self.document_type = attributes[:'documentType']
      end

      if attributes.has_key?(:'residenceId')
        self.residence_id = attributes[:'residenceId']
      end

      if attributes.has_key?(:'clientId')
        self.client_id = attributes[:'clientId']
      end

      if attributes.has_key?(:'userId')
        self.user_id = attributes[:'userId']
      end

      if attributes.has_key?(:'userLastname')
        self.user_lastname = attributes[:'userLastname']
      end

      if attributes.has_key?(:'userFirstname')
        self.user_firstname = attributes[:'userFirstname']
      end

      if attributes.has_key?(:'fileName')
        self.file_name = attributes[:'fileName']
      end

      if attributes.has_key?(:'temporaryUrl')
        self.temporary_url = attributes[:'temporaryUrl']
      end

      if attributes.has_key?(:'temporaryUrlThumb')
        self.temporary_url_thumb = attributes[:'temporaryUrlThumb']
      end

      if attributes.has_key?(:'informationStatus')
        self.information_status = attributes[:'informationStatus']
      end

      if attributes.has_key?(:'createdDate')
        self.created_date = attributes[:'createdDate']
      end

      if attributes.has_key?(:'modifiedDate')
        self.modified_date = attributes[:'modifiedDate']
      end

      if attributes.has_key?(:'totalRows')
        self.total_rows = attributes[:'totalRows']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      document_status_validator = EnumAttributeValidator.new('String', ['PENDING', 'CANCELED', 'VALIDATED', 'REFUSED'])
      return false unless document_status_validator.valid?(@document_status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] document_status Object to be assigned
    def document_status=(document_status)
      validator = EnumAttributeValidator.new('String', ['PENDING', 'CANCELED', 'VALIDATED', 'REFUSED'])
      unless validator.valid?(document_status)
        fail ArgumentError, 'invalid value for "document_status", must be one of #{validator.allowable_values}.'
      end
      @document_status = document_status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          document_id == o.document_id &&
          document_tag == o.document_tag &&
          document_status == o.document_status &&
          document_type_id == o.document_type_id &&
          document_type == o.document_type &&
          residence_id == o.residence_id &&
          client_id == o.client_id &&
          user_id == o.user_id &&
          user_lastname == o.user_lastname &&
          user_firstname == o.user_firstname &&
          file_name == o.file_name &&
          temporary_url == o.temporary_url &&
          temporary_url_thumb == o.temporary_url_thumb &&
          information_status == o.information_status &&
          created_date == o.created_date &&
          modified_date == o.modified_date &&
          total_rows == o.total_rows
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [document_id, document_tag, document_status, document_type_id, document_type, residence_id, client_id, user_id, user_lastname, user_firstname, file_name, temporary_url, temporary_url_thumb, information_status, created_date, modified_date, total_rows].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = TreezorClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
