=begin
#Treezor

#Treezor API.  more info [here](https://www.treezor.com). 

OpenAPI spec version: 0.1.1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.1

=end

require 'date'

module TreezorClient
  class Transfer
    attr_accessor :transfer_id

    attr_accessor :transfer_status

    attr_accessor :transfer_tag

    attr_accessor :wallet_id

    # | Id | Description | |----|----| | 9 | Electronic Money Wallet | | 10 | Payment Account Wallet | | 13 | Mirror Wallet | | 14 | Electronic Money Card (Internal only) | 
    attr_accessor :wallet_type_id

    attr_accessor :beneficiary_wallet_id

    # | Id | Description | |----|----| | 9 | Electronic Money Wallet | | 10 | Payment Account Wallet | | 13 | Mirror Wallet | | 14 | Electronic Money Card (Internal only) | 
    attr_accessor :beneficiary_wallet_type_id

    # Date YYYY-MM-DD
    attr_accessor :transfer_date

    attr_accessor :wallet_event_name

    attr_accessor :wallet_alias

    attr_accessor :beneficiary_wallet_event_name

    attr_accessor :beneficiary_wallet_alias

    attr_accessor :amount

    attr_accessor :currency

    attr_accessor :label

    # Transfer type  | Status | Description | | ------ | -------     | | 1 | Wallet to wallet | | 2 | Card transaction | | 3 | Client fees | | 4 | Credit note | 
    attr_accessor :transfer_type_id

    # Date YYYY-MM-DD HH:MM:SS
    attr_accessor :created_date

    # Date YYYY-MM-DD HH:MM:SS
    attr_accessor :modified_date

    attr_accessor :total_rows

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'transfer_id' => :'transferId',
        :'transfer_status' => :'transferStatus',
        :'transfer_tag' => :'transferTag',
        :'wallet_id' => :'walletId',
        :'wallet_type_id' => :'walletTypeId',
        :'beneficiary_wallet_id' => :'beneficiaryWalletId',
        :'beneficiary_wallet_type_id' => :'beneficiaryWalletTypeId',
        :'transfer_date' => :'transferDate',
        :'wallet_event_name' => :'walletEventName',
        :'wallet_alias' => :'walletAlias',
        :'beneficiary_wallet_event_name' => :'beneficiaryWalletEventName',
        :'beneficiary_wallet_alias' => :'beneficiaryWalletAlias',
        :'amount' => :'amount',
        :'currency' => :'currency',
        :'label' => :'label',
        :'transfer_type_id' => :'transferTypeId',
        :'created_date' => :'createdDate',
        :'modified_date' => :'modifiedDate',
        :'total_rows' => :'totalRows'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'transfer_id' => :'Integer',
        :'transfer_status' => :'String',
        :'transfer_tag' => :'String',
        :'wallet_id' => :'Integer',
        :'wallet_type_id' => :'Integer',
        :'beneficiary_wallet_id' => :'Integer',
        :'beneficiary_wallet_type_id' => :'Integer',
        :'transfer_date' => :'String',
        :'wallet_event_name' => :'String',
        :'wallet_alias' => :'String',
        :'beneficiary_wallet_event_name' => :'String',
        :'beneficiary_wallet_alias' => :'String',
        :'amount' => :'String',
        :'currency' => :'String',
        :'label' => :'String',
        :'transfer_type_id' => :'Integer',
        :'created_date' => :'String',
        :'modified_date' => :'String',
        :'total_rows' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'transferId')
        self.transfer_id = attributes[:'transferId']
      end

      if attributes.has_key?(:'transferStatus')
        self.transfer_status = attributes[:'transferStatus']
      end

      if attributes.has_key?(:'transferTag')
        self.transfer_tag = attributes[:'transferTag']
      end

      if attributes.has_key?(:'walletId')
        self.wallet_id = attributes[:'walletId']
      end

      if attributes.has_key?(:'walletTypeId')
        self.wallet_type_id = attributes[:'walletTypeId']
      end

      if attributes.has_key?(:'beneficiaryWalletId')
        self.beneficiary_wallet_id = attributes[:'beneficiaryWalletId']
      end

      if attributes.has_key?(:'beneficiaryWalletTypeId')
        self.beneficiary_wallet_type_id = attributes[:'beneficiaryWalletTypeId']
      end

      if attributes.has_key?(:'transferDate')
        self.transfer_date = attributes[:'transferDate']
      end

      if attributes.has_key?(:'walletEventName')
        self.wallet_event_name = attributes[:'walletEventName']
      end

      if attributes.has_key?(:'walletAlias')
        self.wallet_alias = attributes[:'walletAlias']
      end

      if attributes.has_key?(:'beneficiaryWalletEventName')
        self.beneficiary_wallet_event_name = attributes[:'beneficiaryWalletEventName']
      end

      if attributes.has_key?(:'beneficiaryWalletAlias')
        self.beneficiary_wallet_alias = attributes[:'beneficiaryWalletAlias']
      end

      if attributes.has_key?(:'amount')
        self.amount = attributes[:'amount']
      end

      if attributes.has_key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.has_key?(:'label')
        self.label = attributes[:'label']
      end

      if attributes.has_key?(:'transferTypeId')
        self.transfer_type_id = attributes[:'transferTypeId']
      end

      if attributes.has_key?(:'createdDate')
        self.created_date = attributes[:'createdDate']
      end

      if attributes.has_key?(:'modifiedDate')
        self.modified_date = attributes[:'modifiedDate']
      end

      if attributes.has_key?(:'totalRows')
        self.total_rows = attributes[:'totalRows']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      transfer_status_validator = EnumAttributeValidator.new('String', ['PENDING', 'CANCELED', 'VALIDATED'])
      return false unless transfer_status_validator.valid?(@transfer_status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] transfer_status Object to be assigned
    def transfer_status=(transfer_status)
      validator = EnumAttributeValidator.new('String', ['PENDING', 'CANCELED', 'VALIDATED'])
      unless validator.valid?(transfer_status)
        fail ArgumentError, 'invalid value for "transfer_status", must be one of #{validator.allowable_values}.'
      end
      @transfer_status = transfer_status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          transfer_id == o.transfer_id &&
          transfer_status == o.transfer_status &&
          transfer_tag == o.transfer_tag &&
          wallet_id == o.wallet_id &&
          wallet_type_id == o.wallet_type_id &&
          beneficiary_wallet_id == o.beneficiary_wallet_id &&
          beneficiary_wallet_type_id == o.beneficiary_wallet_type_id &&
          transfer_date == o.transfer_date &&
          wallet_event_name == o.wallet_event_name &&
          wallet_alias == o.wallet_alias &&
          beneficiary_wallet_event_name == o.beneficiary_wallet_event_name &&
          beneficiary_wallet_alias == o.beneficiary_wallet_alias &&
          amount == o.amount &&
          currency == o.currency &&
          label == o.label &&
          transfer_type_id == o.transfer_type_id &&
          created_date == o.created_date &&
          modified_date == o.modified_date &&
          total_rows == o.total_rows
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [transfer_id, transfer_status, transfer_tag, wallet_id, wallet_type_id, beneficiary_wallet_id, beneficiary_wallet_type_id, transfer_date, wallet_event_name, wallet_alias, beneficiary_wallet_event_name, beneficiary_wallet_alias, amount, currency, label, transfer_type_id, created_date, modified_date, total_rows].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = TreezorClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
